/*
 * Citation.java
 *
 * Created on October 18, 2006, 9:16 AM
 *
 */

package com.schwarcz.enamels.model;

import java.io.Serializable;
import javax.persistence.*;

import java.util.List;

/**
 * Entity class Citation
 * 
 * @author Carl
 */



@NamedQueries(value = 
    {
        @NamedQuery(name="Citation.findByEnamel", 
            query="SELECT c FROM Citation c WHERE c.pieceAka = :aka"),

        @NamedQuery(name="Citation.findByPublication", 
            query="SELECT c FROM Citation c WHERE c.pubId = :pubId")
    }

)

@Entity
public class Citation implements Serializable {

    @Id
    private Long id;
    private String pubId;
    
    private String pieceAka;
    private String changedby;
    

    
    /** Creates a new instance of Citation */
    public Citation() {
    }
    
    
    /**
     * Gets the id of this Citation.
     * @return the id
     */
    public Long getId() {
        return this.id;
    }

    /**
     * Sets the id of this Citation to the specified value.
     * @param id the new id
     */
    public void setId(Long id) {
        this.id = id;
    }

    /**
     * Returns a hash code value for the object.  This implementation computes 
     * a hash code value based on the id fields in this object.
     * @return a hash code value for this object.
     */
    @Override
    public int hashCode() {
        int hash = 0;
        hash += (this.id != null ? this.id.hashCode() : 0);
        return hash;
    }

    /**
     * Determines whether another object is equal to this Citation.  The result is 
     * <code>true</code> if and only if the argument is not null and is a Citation object that 
     * has the same id field values as this object.
     * @param object the reference object with which to compare
     * @return <code>true</code> if this object is the same as the argument;
     * <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Citation)) {
            return false;
        }
        Citation other = (Citation)object;
        if (this.id != other.id && (this.id == null || !this.id.equals(other.id))) return false;
        return true;
    }

    /**
     * Returns a string representation of the object.  This implementation constructs 
     * that representation based on the id fields.
     * @return a string representation of the object.
     */
    @Override
    public String toString() {
        return "Citation[id=" + id 
                + ", pubId=" + getPubId() 
                + ", enamelId=" + getPieceAka()
                + "]";
    }

    public String getPubId() {
        return pubId;
    }

    public void setPubId(String pubId) {
        this.pubId = pubId;
    }

    public String getPieceAka() {
        return pieceAka;
    }

    public void setPieceAka(String pieceAka) {
        this.pieceAka = pieceAka;
    }

    public String getChangedby() {
        return changedby;
    }

    public void setChangedby(String changedby) {
        this.changedby = changedby;
    }

//    public Publication getPublication() {
//        return publication;
//    }
//
//    public void setPublication(Publication publication) {
//        this.publication = publication;
//    }
//
//    public Enamel getEnamel() {
//        return enamel;
//    }
//
//    public void setEnamel(Enamel enamel) {
//        this.enamel = enamel;
//    }
    
}
