/*
 * EnamelFacadeBean.java
 *
 * Created on October 17, 2006, 4:43 PM
 *
 */

package com.schwarcz.enamels.model;

import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;
import java.util.List;


/**
 *
 * @author Carl
 */
@Stateless(mappedName="EnamelFacade")
public class EnamelFacadeBean implements EnamelFacadeLocal, EnamelFacadeRemote {

    @PersistenceContext(unitName="EnamelPU")
    EntityManager em;
    
    /** Creates a new instance of EnamelFacadeBean */
    public EnamelFacadeBean() {
    }

    public Enamel find(String id) {
        Enamel e = em.find(Enamel.class, id);
        return e;
    }
    
    public List<Enamel> findRange(String minId, String maxId){
        List<Enamel> result;
        result = (List<Enamel>)em.createNamedQuery("Enamel.findRange")
            .setParameter("minAka", minId)
            .setParameter("maxAka", maxId)
            .getResultList();
        return result;
    }
    
    public List<Enamel> findAll () {
        List<Enamel> result = (List<Enamel>) em.createNamedQuery("Enamel.findAll").getResultList();
        return result;
    }

    public boolean isReachable() {
     
        return true;
    }
}
