/*
 * Exhibition.java
 *
 * Created on October 23, 2006, 10:07 AM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.schwarcz.enamels.model;

import java.io.Serializable;
import javax.persistence.*;
import java.util.List;

/**
 * Entity class Exhibition
 * 
 * @author Carl
 */

//@NamedQuery(name="Exhibition.findByEnamel", query="SELECT ex FROM Exhibition AS ex, Showpiece AS s WHERE s.enamelId = :enamelId AND s.showId = ex.id ORDER BY ex.year")



@Entity
public class Exhibition implements Serializable {

    @Id
    private String id;
    @Column(name="descript")
    private String description;
    private Long year;
    private String changedBy;
    
    /**
     * The enamels referenced in the exhibition.
     * The join table is "showpiece" where "showId" references this exhibition
     * and "pieceAka" references the enamel.
     */
    @ManyToMany(fetch=FetchType.LAZY)
    @JoinTable(name="showpiece", 
        joinColumns={@JoinColumn(name="showId")},
        inverseJoinColumns={@JoinColumn(name="pieceAka")})
    private List<Enamel> enamels;
    
    /** Creates a new instance of Exhibition */
    public Exhibition() {
    }

    /**
     * Gets the id of this Exhibition.
     * @return the id
     */
    public String getId() {
        return this.id;
    }

    /**
     * Sets the id of this Exhibition to the specified value.
     * @param id the new id
     */
    public void setId(String id) {
        this.id = id;
    }

    /**
     * Returns a hash code value for the object.  This implementation computes 
     * a hash code value based on the id fields in this object.
     * @return a hash code value for this object.
     */
    @Override
    public int hashCode() {
        int hash = 0;
        hash += (this.id != null ? this.id.hashCode() : 0);
        return hash;
    }

    /**
     * Determines whether another object is equal to this Exhibition.  The result is 
     * <code>true</code> if and only if the argument is not null and is a Exhibition object that 
     * has the same id field values as this object.
     * @param object the reference object with which to compare
     * @return <code>true</code> if this object is the same as the argument;
     * <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Exhibition)) {
            return false;
        }
        Exhibition other = (Exhibition)object;
        if (this.id != other.id && (this.id == null || !this.id.equals(other.id))) return false;
        return true;
    }

    /**
     * Returns a string representation of the object.  This implementation constructs 
     * that representation based on the id fields.
     * @return a string representation of the object.
     */
    @Override
    public String toString() {
        return "com.schwarcz.enamels.model.Exhibition[id=" + id + "]";
    }

    public List<Enamel> getEnamels() {
        return enamels;
    }

    public void setEnamels(List<Enamel> enamels) {
        this.enamels = enamels;
    }
    
}
