/*
 * ExhibitionFacadeBean.java
 *
 * Created on October 23, 2006, 2:32 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.schwarcz.enamels.model;
import com.schwarcz.util.LoggingSetup;
import java.util.List;
import com.schwarcz.enamels.model.Exhibition;
import javax.annotation.PostConstruct;
import javax.annotation.PreDestroy;
import javax.ejb.Stateless;
import javax.persistence.*;
import org.apache.log4j.*;

/**
 *
 * @author Carl
 */
@Stateless(mappedName="ExhibitionFacade")
public class ExhibitionFacadeBean implements ExhibitionFacadeRemote, ExhibitionFacadeLocal {
    
    @PersistenceContext(unitName="EnamelPU")
    EntityManager em;
    
    Logger logger;
    
    String findByEnamel = "SELECT ex FROM Exhibition AS ex, Showpiece AS s WHERE s.enamelId = :enamelId AND s.showId = ex.id ORDER BY ex.year";

    /** Creates a new instance of ExhibitionFacadeBean */
    public ExhibitionFacadeBean() {
    }

    public List<Exhibition> findByEnamel(String id) {
        logger.info("findByEnamel");
        List<Exhibition> result;
//        result = (List<Exhibition>)em.createNamedQuery("Exhibition.findByEnamel")
        
        Query query = em.createQuery(findByEnamel);
        query.setParameter("enamelId", id);
        result = (List<Exhibition>) query.getResultList();
        return result;
    }
    
    
    
    @PostConstruct
    private void init(){
        new LoggingSetup();
        logger = Logger.getLogger("ExhibitionFacadeBean");
        logger.info("init complete");
    }
    
    @PreDestroy
    private void teardown(){
        logger = null;
    }

    public List testQuery(String queryString) {
        Query query;
        List results;
        logger.info("testQuery: " + queryString);
        
        results = em.createQuery(queryString).getResultList();
        
        return results;
    }

    public boolean isReachable() {
       
        return true;
    }
    
}
