/*
 * EnamelFacadeRemoteTest.java
 * JUnit based test
 *
 * Created on October 21, 2006, 4:04 PM
 */

package com.schwarcz.enamels.model;

import junit.framework.*;
import javax.ejb.Remote;
import java.util.List;
import com.schwarcz.util.*;
import org.apache.log4j.*;
/**
 *
 * @author Carl
 */
public class EnamelFacadeRemoteTest extends TestCase {
    
    Logger logger = Logger.getLogger(this.getName());
    
    EnamelFacadeRemote efr;
    
    LoggingSetup setup = new LoggingSetup();
    
    
    public EnamelFacadeRemoteTest(String testName) {
        super(testName);
        logger.setLevel(Level.DEBUG);
        
    }
    
    protected void setUp() throws Exception {
        efr = (EnamelFacadeRemote) ServiceLocator.lookup("EnamelFacade");
        logger.debug("got EnamelFacadeRemote ok");
    }
    
    protected void tearDown() throws Exception {
    }
    
    /**
     * Test of find method, of modelEnamelFacadeRemote.
     */
    public void testFindAll() {
        List<Enamel> results;
        int expectedCount = 1067;
        results = efr.findAll();
        
        assertTrue("There should be at least " + expectedCount + " enamels.", results.size() >= expectedCount);
    }
    
    /**
     * Test of findRange method, of EnamelFacadeRemote.
     */
    public void testFindRange() {
        String minId = "0400";
        String maxId = "0500";
        int expectedCount = 93;
        List<Enamel> results;
        
        results = efr.findRange(minId, maxId);
        
        assertNotNull(results);
        assertEquals("size of result", expectedCount, results.size());
    }
    
    /**
     * Test of findAll method, of EnamelFacadeRemote.
     */
    public void testFind0323() {
        
        Enamel e = tester ("0323", 0, 0);
    }
    
    public void testFind0571 () {
        Enamel e = tester ("0571", 2, 0);
        
    }     
        
    public void testReachable() {
        assertTrue(efr.isReachable());
    }
    
    private Enamel tester (String enamelId, int numCitations, int numShows){

        Enamel e = efr.find(enamelId);
        assertEquals(enamelId, e.getId());
        List<Publication> pubs = e.getPublications();
        assertEquals(numCitations, pubs.size());
        logger.info ("pubs for " + enamelId);
        for (Publication p : pubs) {
            logger.info("    " + p.toString());
        }
        
        return e;
        
    }
}
