/*
 * ExhibitionFacadeRemoteTest.java
 * JUnit based test
 *
 * Created on October 23, 2006, 2:42 PM
 */

package com.schwarcz.enamels.model;

import junit.framework.*;
import javax.ejb.Remote;
import java.util.List;
import com.schwarcz.util.ServiceLocator;

/**
 *
 * @author Carl
 */
public class ExhibitionFacadeRemoteTest extends TestCase {
    
    ExhibitionFacadeRemote efr;
    
    public ExhibitionFacadeRemoteTest(String testName) {
        super(testName);
    }

    protected void setUp() throws Exception {
        efr = (ExhibitionFacadeRemote) ServiceLocator.lookup("ExhibitionFacade");
    }

    protected void tearDown() throws Exception {
    }

    /**
     * Test of findByEnamel method, of class com.schwarcz.enamels.model.ExhibitionFacadeRemote.
     */
//    public void testFindByEnamel() {
//        String aka = "0301";
//        assertNotNull (efr);
//        List<Exhibition> result = efr.findByEnamel(aka);
//        assertTrue ("At least five shows", (5 <= result.size()));
//        
//    }
    
    public void testQuery1() {
        //"SELECT ex FROM Exhibition AS ex, Showpiece AS s WHERE s.enamelId = :enamelId AND s.showId = ex.id ORDER BY ex.year")

        String query = "SELECT sh FROM Showpiece as sh WHERE sh.enamelId = '0301' ";
        
        List list = efr.testQuery(query);
    }
    
    public void testQuery2() {
       

        String query = "SELECT ex FROM Exhibition as ex, Showpiece as sh WHERE sh.enamelId = '0301' AND ex.id = sh.showId";
        
        List list = efr.testQuery(query);
    }
    
    public void testQuery3() {
        

        String query = "SELECT ex FROM Exhibition as ex, Showpiece as sh WHERE sh.enamelId = '0301' AND ex.id = sh.showId";
        
        List list = efr.testQuery(query);
    }
    
    public void testQuery4() {
        

        String query = "SELECT ex FROM Exhibition as ex " +
                " WHERE ex.id IN " +
                " ( SELECT sp.showId FROM Showpiece AS sp WHERE sp.enamelId = '0301' )";
        
        List list = efr.testQuery(query);
    }
}
